function E = calculateEnergyComponents(~,psi,Params,Transf,VDk,V)

    %Parameters
    
    KEop= 0.5*(Transf.KX.^2+Transf.KY.^2+Transf.KZ.^2);
    normfac = Params.Lx*Params.Ly*Params.Lz/numel(psi);
    
    % DDIs
    frho = fftn(abs(psi).^2);
    Phi = real(ifftn(frho.*VDk));
    
    Eddi = 0.5*Params.gdd*Phi.*abs(psi).^2;
    E.Eddi = trapz(Eddi(:))*Transf.dx*Transf.dy*Transf.dz;
    
    % EddiTot = trapz(Eddi(:))*Transf.dx*Transf.dy*Transf.dz;
    
    %Kinetic energy
    % psik = ifftshift(fftn(fftshift(psi)))*normfac;
    
    Ekin = KEop.*abs(fftn(psi)*normfac).^2;
    E.Ekin = trapz(Ekin(:))*Transf.dkx*Transf.dky*Transf.dkz/(2*pi)^3;
    
    % Potential energy
    Epot = V.*abs(psi).^2;
    E.Epot = trapz(Epot(:))*Transf.dx*Transf.dy*Transf.dz;
    
    %Contact interactions
    Eint = 0.5*Params.gs*abs(psi).^4;
    E.Eint = trapz(Eint(:))*Transf.dx*Transf.dy*Transf.dz;
    
    %Quantum fluctuations
    Eqf = 0.4*Params.gammaQF*abs(psi).^5;
    E.Eqf = trapz(Eqf(:))*Transf.dx*Transf.dy*Transf.dz;
    
end
